// Generated by CoffeeScript 1.10.0
(function() {
  var assembly, calculator, copper, courtyard, silkscreen, sprintf,
    slice = [].slice;

  sprintf = require('sprintf-js').sprintf;

  assembly = require('./assembly');

  calculator = require('./calculator');

  copper = require('./copper');

  courtyard = require('./courtyard');

  silkscreen = require('./silkscreen');

  module.exports = function(pattern, element) {
    var abbr, housing, leadCount, option, pad, padParams, ref, settings;
    housing = element.housing;
    settings = pattern.settings;
    leadCount = (ref = housing.leadCount) != null ? ref : Object.keys(element.pins).length;
    if (housing.cga) {
      abbr = 'CGA';
      option = 'cga';
    } else if (housing.lga) {
      abbr = 'LGA';
      option = 'lga';
    } else {
      abbr = 'BGA';
      option = 'bga';
    }
    if (pattern.name == null) {
      pattern.name = sprintf.apply(null, ["%s%d%s%dP%dX%d_%dX%dX%d%s", abbr, leadCount, settings.ball.collapsible ? 'C' : 'N'].concat(slice.call([housing.pitch * 100, housing.columnCount, housing.rowCount, housing.bodyLength.nom * 100, housing.bodyWidth.nom * 100, housing.height.max * 100].map((function(_this) {
        return function(v) {
          return Math.round(v);
        };
      })(this))), [settings.densityLevel]));
    }
    if (housing.rowPitch == null) {
      housing.rowPitch = housing.pitch;
    }
    if (housing.columnPitch == null) {
      housing.columnPitch = housing.pitch;
    }
    padParams = calculator.gridArray(pattern, housing, option);
    pad = {
      type: 'smd',
      width: padParams.width,
      height: padParams.height,
      shape: housing.lga ? 'rectangle' : 'circle',
      layer: ['topCopper', 'topMask', 'topPaste']
    };
    copper.gridArray(pattern, element, pad);
    silkscreen.gridArray(pattern, housing);
    assembly.polarized(pattern, housing);
    return courtyard.gridArray(pattern, housing, padParams.courtyard);
  };

}).call(this);
