// Generated by CoffeeScript 1.10.0
(function() {
  var assembly, calculator, copper, courtyard, silkscreen, sprintf,
    slice = [].slice;

  sprintf = require('sprintf-js').sprintf;

  assembly = require('./assembly');

  calculator = require('./calculator');

  copper = require('./copper');

  courtyard = require('./courtyard');

  silkscreen = require('./silkscreen');

  module.exports = function(pattern, element) {
    var abbr, hasTab, housing, leadCount, length, option, padParams, ref, settings, width;
    housing = element.housing;
    settings = pattern.settings;
    leadCount = (ref = housing.leadCount) != null ? ref : 2 * (housing.rowCount + housing.columnCount);
    hasTab = (housing.tabWidth != null) && (housing.tabLength != null);
    if (hasTab) {
      ++leadCount;
    }
    if (housing.columnSpan == null) {
      housing.columnSpan = housing.leadSpan;
    }
    if (housing.rowSpan == null) {
      housing.rowSpan = housing.leadSpan;
    }
    if (housing.cqfp) {
      abbr = 'CQFP';
      option = 'qfp';
      length = housing.rowSpan.nom;
      width = housing.columnSpan.nom;
    } else if (housing.qfn) {
      abbr = (housing.pullBack != null ? 'P' : '') + 'QFN';
      option = 'qfn';
      length = housing.bodyLength.nom;
      width = housing.bodyWidth.nom;
    } else {
      abbr = 'QFP';
      option = 'qfp';
      length = housing.columnSpan.nom;
      width = housing.rowSpan.nom;
    }
    if (pattern.name == null) {
      pattern.name = sprintf.apply(null, ["%s%dP%dX%dX%d-%d%s", abbr].concat(slice.call([housing.pitch * 100, length * 100, width * 100, housing.height.max * 100, leadCount].map((function(_this) {
        return function(v) {
          return Math.round(v);
        };
      })(this))), [settings.densityLevel]));
    }
    padParams = calculator.quad(pattern, housing, option);
    padParams.rowPad = {
      type: 'smd',
      shape: 'rectangle',
      width: padParams.width1,
      height: padParams.height1,
      distance: padParams.distance1,
      layer: ['topCopper', 'topMask', 'topPaste']
    };
    padParams.columnPad = {
      type: 'smd',
      shape: 'rectangle',
      width: padParams.height2,
      height: padParams.width2,
      distance: padParams.distance2,
      layer: ['topCopper', 'topMask', 'topPaste']
    };
    copper.quad(pattern, element, padParams);
    silkscreen.quad(pattern, housing);
    assembly.polarized(pattern, housing);
    courtyard.quad(pattern, housing, padParams.courtyard);
    return copper.tab(pattern, element);
  };

}).call(this);
