// Generated by CoffeeScript 1.10.0
(function() {
  var assembly, calculator, courtyard, silkscreen, sprintf,
    slice = [].slice;

  sprintf = require('sprintf-js').sprintf;

  assembly = require('./common/assembly');

  calculator = require('./common/calculator');

  courtyard = require('./common/courtyard');

  silkscreen = require('./common/silkscreen');

  module.exports = function(pattern, element) {
    var column, columnCount, columnPitch, housing, i, j, leadCount, num, pad, padParams, ref, ref1, ref2, ref3, ref4, ref5, ref6, row, rowCount, rowPitch, settings, throughHole, x, y;
    housing = element.housing;
    settings = pattern.settings;
    leadCount = housing.rowCount * housing.columnCount;
    if (pattern.name == null) {
      pattern.name = sprintf.apply(null, ["CON%02dP%dX%dX%d-%d%s"].concat(slice.call([housing.pitch * 100, housing.bodyLength.nom * 10, housing.bodyWidth.nom * 10, housing.height.max * 10, leadCount].map((function(_this) {
        return function(v) {
          return Math.round(v);
        };
      })(this))), [settings.densityLevel]));
    }
    rowPitch = (ref = housing.rowPitch) != null ? ref : housing.pitch;
    columnPitch = (ref1 = housing.columnPitch) != null ? ref1 : housing.pitch;
    rowCount = housing.rowCount;
    columnCount = housing.columnCount;
    throughHole = (typeof drillDiameter !== "undefined" && drillDiameter !== null) || housing.th;
    if (throughHole) {
      padParams = calculator.throughHole(pattern, housing);
      pad = {
        type: 'through-hole',
        drill: (ref2 = housing.drillDiameter) != null ? ref2 : padParams.drill,
        width: (ref3 = housing.padWidth) != null ? ref3 : padParams.diameter,
        height: (ref4 = housing.padHeight) != null ? ref4 : padParams.diameter,
        shape: 'rectangle',
        layer: ['topCopper', 'topMask', 'topPaste', 'bottomCopper', 'bottomMask', 'bottomPaste']
      };
    } else {
      pad = {
        type: 'smd',
        width: housing.padWidth,
        height: housing.padHeight,
        shape: 'rectangle',
        layer: ['topCopper', 'topMask', 'topPaste']
      };
    }
    num = 1;
    y = -rowPitch * (rowCount / 2 - 0.5);
    for (row = i = 1, ref5 = rowCount; 1 <= ref5 ? i <= ref5 : i >= ref5; row = 1 <= ref5 ? ++i : --i) {
      x = -columnPitch * (columnCount / 2 - 0.5);
      for (column = j = 1, ref6 = columnCount; 1 <= ref6 ? j <= ref6 : j >= ref6; column = 1 <= ref6 ? ++j : --j) {
        pad.x = x;
        pad.y = y;
        pattern.pad(num++, pad);
        if (throughHole) {
          pad.shape = 'circle';
        }
        x += columnPitch;
      }
      y += rowPitch;
    }
    silkscreen.connector(pattern, housing);
    assembly.polarized(pattern, housing);
    return courtyard.connector(pattern, housing, 1);
  };

}).call(this);
