// Generated by CoffeeScript 1.10.0
(function() {
  var assembly, calculator, copper, copperPads, courtyard, pinNumber, silkscreen;

  assembly = require('./common/assembly');

  calculator = require('./common/calculator');

  copper = require('./common/copper');

  courtyard = require('./common/courtyard');

  silkscreen = require('./common/silkscreen');

  pinNumber = 0;

  copperPads = function(pattern, element, suffix) {
    var column, columnCount, columnCounts, columnDX, columnDXs, columnDY, columnDYs, columnPitch, drillDiameter, hasPads, housing, i, j, k, l, len, numbers, p, pad, padDiameter, padHeight, padWidth, pins, points, ref, ref1, ref10, ref2, ref3, ref4, ref5, ref6, ref7, ref8, ref9, row, rowCount, rowDX, rowDXs, rowDY, rowDYs, rowPitch, x, y;
    if (suffix == null) {
      suffix = '';
    }
    housing = element.housing;
    pins = element.pins;
    numbers = Object.keys(pins);
    if (!((housing['drillDiameter' + suffix] != null) || ((housing['padWidth' + suffix] != null) && (housing['padHeight' + suffix] != null)))) {
      return false;
    }
    hasPads = false;
    if (housing['drillDiameter' + suffix] != null) {
      drillDiameter = housing['drillDiameter' + suffix];
      padDiameter = calculator.padDiameter(pattern, housing, drillDiameter);
      padWidth = (ref = housing['padWidth' + suffix]) != null ? ref : padDiameter;
      padHeight = (ref1 = housing['padHeight' + suffix]) != null ? ref1 : padDiameter;
      pad = {
        type: 'through-hole',
        drill: housing['drillDiameter' + suffix],
        width: padWidth,
        height: padHeight,
        shape: !pinNumber ? 'rectangle' : 'circle',
        layer: ['topCopper', 'topMask', 'topPaste', 'bottomCopper', 'bottomMask', 'bottomPaste']
      };
    } else {
      pad = {
        type: 'smd',
        width: housing['padWidth' + suffix],
        height: housing['padHeight' + suffix],
        shape: 'rectangle',
        layer: ['topCopper', 'topMask', 'topPaste']
      };
    }
    if (housing['padPosition' + suffix] != null) {
      hasPads = true;
      points = pattern.parsePosition(housing['padPosition' + suffix]);
      for (i = j = 0, len = points.length; j < len; i = ++j) {
        p = points[i];
        pad.x = p.x;
        pad.y = p.y;
        pattern.pad(numbers[pinNumber++], pad);
        if (housing['drillDiameter' + suffix] != null) {
          pad.shape = 'circle';
        }
      }
    } else if ((housing['rowCount' + suffix] != null) && (housing['columnCount' + suffix] != null)) {
      hasPads = true;
      rowCount = housing['rowCount' + suffix];
      if (rowCount === 1) {
        rowPitch = 0;
      } else {
        rowPitch = (ref2 = housing['rowPitch' + suffix]) != null ? ref2 : housing['pitch' + suffix];
      }
      rowDXs = pattern.parseArray(housing['rowDX' + suffix]);
      rowDYs = pattern.parseArray(housing['rowDY' + suffix]);
      columnCounts = pattern.parseArray(housing['columnCount' + suffix]);
      columnPitch = (ref3 = housing['columnPitch' + suffix]) != null ? ref3 : housing['pitch' + suffix];
      columnDXs = pattern.parseArray(housing['columnDX' + suffix]);
      columnDYs = pattern.parseArray(housing['columnDY' + suffix]);
      y = -rowPitch * (rowCount - 1) / 2;
      for (row = k = 0, ref4 = rowCount - 1; 0 <= ref4 ? k <= ref4 : k >= ref4; row = 0 <= ref4 ? ++k : --k) {
        columnCount = (ref5 = columnCounts[row]) != null ? ref5 : columnCounts[0];
        rowDX = (ref6 = rowDXs[row]) != null ? ref6 : rowDXs[0];
        rowDY = (ref7 = rowDYs[row]) != null ? ref7 : rowDYs[0];
        x = -columnPitch * (columnCount - 1) / 2;
        for (column = l = 0, ref8 = columnCount - 1; 0 <= ref8 ? l <= ref8 : l >= ref8; column = 0 <= ref8 ? ++l : --l) {
          columnDX = (ref9 = columnDXs[row]) != null ? ref9 : columnDXs[0];
          columnDY = (ref10 = columnDYs[row]) != null ? ref10 : columnDYs[0];
          pad.x = x + rowDX + columnDX;
          pad.y = y + rowDY + columnDY;
          pattern.pad(numbers[pinNumber++], pad);
          if (housing['drillDiameter' + suffix] != null) {
            pad.shape = 'circle';
          }
          x += columnPitch;
        }
        y += rowPitch;
      }
    }
    return hasPads;
  };

  module.exports = function(pattern, element) {
    var bodyPosition, housing, i;
    housing = element.housing;
    if (pattern.name == null) {
      pattern.name = element.group + '_' + element.name.toUpperCase();
    }
    if (housing.bodyPosition == null) {
      housing.bodyPosition = '0, 0';
    }
    bodyPosition = pattern.parsePosition(housing.bodyPosition);
    pattern.center(-bodyPosition[0].x, -bodyPosition[0].y);
    pinNumber = 0;
    copperPads(pattern, element);
    i = 1;
    while (true) {
      if (!copperPads(pattern, element, i++)) {
        break;
      }
    }
    pattern.center(0, 0);
    copper.mask(pattern);
    silkscreen.body(pattern, housing);
    if (housing.polarized) {
      assembly.polarized(pattern, housing);
    } else {
      assembly.body(pattern, housing);
    }
    return courtyard.boundary(pattern, housing);
  };

}).call(this);
