// Generated by CoffeeScript 1.10.0
(function() {
  var calculator, copper, courtyard, silkscreen;

  calculator = require('./common/calculator');

  copper = require('./common/copper');

  courtyard = require('./common/courtyard');

  silkscreen = require('./common/silkscreen');

  module.exports = function(pattern, element) {
    var angle, count, housing, i, j, pad, r, ref, ref1, ref2, ref3, ref4, settings, viaPad;
    housing = element.housing;
    settings = pattern.settings;
    if (pattern.name == null) {
      pattern.name = element.name.toUpperCase();
    }
    pad = {
      x: 0,
      y: 0,
      drill: housing.drillDiameter,
      shape: 'circle'
    };
    if ((housing.padDiameter != null) || (housing.padWidth != null) || (housing.padHeight != null)) {
      if (housing.padWidth == null) {
        housing.padWidth = housing.padDiameter;
      }
      if (housing.padHeight == null) {
        housing.padHeight = housing.padDiameter;
      }
      pad.type = 'through-hole';
      pad.layer = ['topCopper', 'topMask', 'topPaste', 'bottomCopper', 'bottomMask', 'bottomPaste'];
      pad.width = (ref = housing.padDiameter) != null ? ref : housing.padWidth;
      pad.height = (ref1 = housing.padDiameter) != null ? ref1 : housing.padHeight;
    } else {
      pad.type = 'mounting-hole';
      pad.layer = ['topCopper', 'topMask', 'bottomCopper', 'bottomMask'];
      pad.width = housing.drillDiameter;
      pad.height = housing.drillDiameter;
      pad.shape = 'circle';
    }
    pattern.pad(1, pad);
    copper.mask(pattern);
    if (housing.viaDiameter != null) {
      viaPad = {
        type: 'through-hole',
        shape: 'circle',
        drill: housing.viaDiameter,
        width: housing.viaDiameter + settings.minimum.ringWidth,
        height: housing.viaDiameter + settings.minimum.ringWidth,
        layer: ['topCopper', 'bottomCopper']
      };
      count = (ref2 = housing.viaCount) != null ? ref2 : 8;
      r = housing.drillDiameter / 2 + (((ref3 = housing.padDiameter) != null ? ref3 : housing.padWidth) - housing.drillDiameter) / 4;
      for (i = j = 0, ref4 = count - 1; 0 <= ref4 ? j <= ref4 : j >= ref4; i = 0 <= ref4 ? ++j : --j) {
        angle = i * 2 * Math.PI / count;
        viaPad.x = r * Math.cos(angle);
        viaPad.y = r * Math.sin(angle);
        pattern.pad(1, viaPad);
      }
    }
    if (housing.keepout == null) {
      housing.keepout = {
        M: 0.5,
        N: 0.25,
        L: 0.12
      }[settings.densityLevel];
    }
    courtyard.preamble(pattern, housing).circle(0, 0, pad.width / 2 + housing.keepout);
    return pattern.layer('topAssembly').lineWidth(settings.lineWidth.assembly).attribute('refDes', {
      x: 0,
      y: 0,
      halign: 'center',
      valign: 'center'
    }).attribute('value', {
      text: pattern.name,
      x: 0,
      y: 0,
      halign: 'center',
      valign: 'center',
      visible: false
    });
  };

}).call(this);
