// Generated by CoffeeScript 1.10.0
(function() {
  var intersects, pinTextWidth;

  intersects = function(s1, s2) {
    var a1, a2, a3, a4;
    a1 = (s1[0] >= s2[0]) && (s1[0] <= s2[1]);
    a2 = (s1[1] >= s2[0]) && (s1[1] <= s2[1]);
    a3 = (s2[0] >= s1[0]) && (s2[0] <= s1[1]);
    a4 = (s2[1] >= s1[0]) && (s2[1] <= s1[1]);
    return a1 || a2 || a3 || a4;
  };

  pinTextWidth = function(symbol, pin, space, visible) {
    if (visible) {
      return symbol.textWidth(pin.name, 'pin') + space;
    } else {
      return 0;
    }
  };

  module.exports = function(symbol, element, icon) {
    var aa, ab, attributeSpace, bottom, bottomPins, bottomRects, bottomY, dx, dy, h, height, i, j, k, l, left, leftPins, leftRects, leftX, len, len1, len10, len11, len12, len13, len14, len2, len3, len4, len5, len6, len7, len8, len9, m, n, o, p, pin, pinIconHeight, pinIconWidth, pinLength, pinSpace, pins, pitch, q, r, rects, ref, ref1, ref2, ref3, ref4, ref5, ref6, right, rightPins, rightX, s, schematic, settings, space, t, top, topPins, topRects, topY, u, v, w, width, x, x1, x2, y, y1, y2, z;
    schematic = element.schematic;
    settings = symbol.settings;
    pitch = symbol.alignToGrid((ref = settings.pitch) != null ? ref : 5);
    pinLength = symbol.alignToGrid((ref1 = settings.pinLength) != null ? ref1 : 10);
    pinSpace = (ref2 = schematic.pinSpace) != null ? ref2 : settings.space.pin;
    space = settings.space["default"];
    left = symbol.left;
    right = symbol.right;
    top = symbol.top;
    bottom = symbol.bottom;
    pins = element.pins;
    width = pitch * (Math.max(top.length, bottom.length) + 1);
    height = pitch * (Math.max(left.length, right.length) + 1);
    leftX = -width / 2;
    rightX = width / 2;
    topY = -height / 2;
    bottomY = height / 2;
    rects = [];
    if (icon != null) {
      rects.push({
        x1: -icon.width / 2,
        y1: -icon.height / 2,
        x2: icon.width / 2,
        y2: icon.height / 2
      });
    }
    if (schematic.pinIcon != null) {
      pinSpace += schematic.pinIcon.width;
      pinIconWidth = schematic.pinIcon.width;
      pinIconHeight = schematic.pinIcon.height;
    }
    dx = settings.fontSize.pin / 2 + space;
    y = topY;
    topPins = [];
    topRects = [];
    x = -pitch * (top.length / 2 - 0.5);
    for (j = 0, len = top.length; j < len; j++) {
      i = top[j];
      if (i === '-') {
        x += pitch;
        continue;
      }
      pin = pins[i];
      if (pin == null) {
        continue;
      }
      pin.x = x;
      pin.length = pinLength;
      pin.orientation = 'down';
      topPins.push(pin);
      h = pinTextWidth(symbol, pin, pinSpace, schematic.showPinNames);
      if (y > (-h - space)) {
        y = -h - space;
      }
      x1 = x - dx;
      x2 = x + dx;
      for (k = 0, len1 = rects.length; k < len1; k++) {
        r = rects[k];
        if (intersects([x1, x2], [r.x1, r.x2])) {
          y1 = r.y1 - h - space;
          if (y > y1) {
            y = y1;
          }
        }
      }
      x += pitch;
      topRects.push({
        x1: x1,
        y1: 0,
        x2: x2,
        y2: h
      });
    }
    topY = symbol.alignToGrid(y, 'floor');
    for (l = 0, len2 = topRects.length; l < len2; l++) {
      r = topRects[l];
      r.y1 += topY;
      r.y2 += topY;
      rects.push(r);
    }
    y = bottomY;
    bottomPins = [];
    bottomRects = [];
    x = -pitch * (bottom.length / 2 - 0.5);
    for (m = 0, len3 = bottom.length; m < len3; m++) {
      i = bottom[m];
      if (i === '-') {
        x += pitch;
        continue;
      }
      pin = pins[i];
      if (pin == null) {
        continue;
      }
      pin.x = x;
      pin.length = pinLength;
      pin.orientation = 'up';
      bottomPins.push(pin);
      h = pinTextWidth(symbol, pin, pinSpace, schematic.showPinNames);
      if (y < (h + space)) {
        y = h + space;
      }
      x1 = x - dx;
      x2 = x + dx;
      for (n = 0, len4 = rects.length; n < len4; n++) {
        r = rects[n];
        if (intersects([x1, x2], [r.x1, r.x2])) {
          y2 = r.y2 + h + space;
          if (y < y2) {
            y = y2;
          }
        }
      }
      x += pitch;
      bottomRects.push({
        x1: x1,
        y1: -h,
        x2: x2,
        y2: 0
      });
    }
    bottomY = symbol.alignToGrid(y, 'ceil');
    for (o = 0, len5 = bottomRects.length; o < len5; o++) {
      r = bottomRects[o];
      r.y1 += bottomY;
      r.y2 += bottomY;
      rects.push(r);
    }
    x = leftX;
    dy = settings.fontSize.pin / 2 + space;
    leftPins = [];
    leftRects = [];
    y = -pitch * (left.length / 2 - 0.5);
    for (p = 0, len6 = left.length; p < len6; p++) {
      i = left[p];
      if (i === '-') {
        y += pitch;
        continue;
      }
      pin = pins[i];
      if (pin == null) {
        continue;
      }
      pin.y = y;
      pin.length = pinLength;
      pin.orientation = 'right';
      leftPins.push(pin);
      w = pinTextWidth(symbol, pin, pinSpace, schematic.showPinNames);
      if (x > (-w - space)) {
        x = -w - space;
      }
      y1 = y - dy;
      y2 = y + dy;
      for (q = 0, len7 = rects.length; q < len7; q++) {
        r = rects[q];
        if (intersects([y1, y2], [r.y1, r.y2])) {
          x1 = r.x1 - w - space;
          if (x > x1) {
            x = x1;
          }
        }
      }
      y += pitch;
      leftRects.push({
        x1: 0,
        y1: y1,
        x2: w,
        y2: y2
      });
    }
    leftX = symbol.alignToGrid(x, 'floor');
    for (s = 0, len8 = leftRects.length; s < len8; s++) {
      r = leftRects[s];
      r.x1 += leftX;
      r.x2 += leftX;
      rects.push(r);
    }
    x = rightX;
    rightPins = [];
    y = -pitch * (right.length / 2 - 0.5);
    for (t = 0, len9 = right.length; t < len9; t++) {
      i = right[t];
      if (i === '-') {
        y += pitch;
        continue;
      }
      pin = pins[i];
      if (pin == null) {
        continue;
      }
      pin.y = y;
      pin.length = pinLength;
      pin.orientation = 'left';
      rightPins.push(pin);
      w = pinTextWidth(symbol, pin, pinSpace, schematic.showPinNames);
      if (x < (w + space)) {
        x = w + space;
      }
      y1 = y - dy;
      y2 = y + dy;
      for (u = 0, len10 = rects.length; u < len10; u++) {
        r = rects[u];
        if (intersects([y1, y2], [r.y1, r.y2])) {
          x2 = r.x2 + w + space;
          if (x < x2) {
            x = x2;
          }
        }
      }
      y += pitch;
    }
    rightX = symbol.alignToGrid(x, 'ceil');
    width = rightX - leftX;
    height = bottomY - topY;
    width = symbol.alignToGrid(width, 'ceil');
    height = symbol.alignToGrid(height, 'ceil');
    symbol.lineWidth(settings.lineWidth.thick).rectangle(0, 0, width, height, settings.fill);
    if (icon != null) {
      icon.draw(-leftX, -topY);
    }
    for (v = 0, len11 = leftPins.length; v < len11; v++) {
      pin = leftPins[v];
      pin.x = -pinLength;
      pin.y -= topY;
      pin.space = pinSpace;
      symbol.pin(pin);
      if ((ref3 = schematic.pinIcon) != null) {
        ref3.draw(pin.x + pinLength + pinIconWidth / 2, pin.y);
      }
    }
    for (z = 0, len12 = rightPins.length; z < len12; z++) {
      pin = rightPins[z];
      pin.x = width + pinLength;
      pin.y -= topY;
      pin.space = pinSpace;
      symbol.pin(pin);
      if ((ref4 = schematic.pinIcon) != null) {
        ref4.draw(pin.x - pinLength - pinIconWidth / 2, pin.y);
      }
    }
    for (aa = 0, len13 = topPins.length; aa < len13; aa++) {
      pin = topPins[aa];
      pin.x -= leftX;
      pin.y = -pinLength;
      pin.space = pinSpace;
      symbol.pin(pin);
      if ((ref5 = schematic.pinIcon) != null) {
        ref5.draw(pin.x, pin.y + pinLength + pinIconHeight / 2);
      }
    }
    for (ab = 0, len14 = bottomPins.length; ab < len14; ab++) {
      pin = bottomPins[ab];
      pin.x -= leftX;
      pin.y = height + pinLength;
      pin.space = pinSpace;
      symbol.pin(pin);
      if ((ref6 = schematic.pinIcon) != null) {
        ref6.draw(pin.x, pin.y - pinLength - pinIconHeight / 2);
      }
    }
    attributeSpace = settings.space.attribute;
    if (element.parts != null) {
      return symbol.attribute('refDes', {
        x: 0,
        y: -settings.fontSize.name - 2 * attributeSpace,
        halign: 'left',
        valign: 'bottom'
      }).attribute('name', {
        x: 0,
        y: -attributeSpace,
        halign: 'left',
        valign: 'bottom'
      });
    } else {
      if (topPins.length > 0) {
        symbol.attribute('refDes', {
          x: 0,
          y: -attributeSpace,
          halign: 'left',
          valign: 'bottom'
        });
      } else {
        symbol.attribute('refDes', {
          x: width / 2,
          y: -attributeSpace,
          halign: 'center',
          valign: 'bottom'
        });
      }
      if (bottomPins.length > 0) {
        return symbol.attribute('name', {
          x: bottomPins[bottomPins.length - 1].x + attributeSpace,
          y: height + attributeSpace,
          halign: 'left',
          valign: 'top'
        });
      } else {
        return symbol.attribute('name', {
          x: width / 2,
          y: height + attributeSpace,
          halign: 'center',
          valign: 'top'
        });
      }
    }
  };

}).call(this);
