// Generated by CoffeeScript 1.10.0
(function() {
  var Icons;

  Icons = require('./common/icons');

  module.exports = function(symbol, element, styleIcons) {
    var anode, cathode, decorated, height, i, icon, j, k, len, nc, needEnclosure, numbers, pinLength, pins, pitch, ref, schematic, settings, v, width;
    element.refDes = 'D';
    schematic = element.schematic;
    settings = symbol.settings;
    pins = element.pins;
    numbers = Object.keys(pins);
    decorated = numbers.length > 2;
    if (schematic.showPinNames == null) {
      schematic.showPinNames = false;
    }
    if (schematic.showPinNumbers == null) {
      schematic.showPinNumbers = decorated ? true : false;
    }
    icon = styleIcons != null ? new styleIcons.Diode(symbol, element) : new Icons.Diode(symbol, element);
    cathode = 1;
    anode = 2;
    nc = [];
    for (k in pins) {
      v = pins[k];
      v.name = v.name.replace('K', 'C');
      switch (v.name) {
        case 'A':
          anode = v.number;
          break;
        case 'C':
          cathode = v.number;
          break;
        case 'NC':
          nc.push(v.number);
          break;
        default:
          needEnclosure = true;
      }
    }
    if (needEnclosure) {
      schematic.showPinNames = true;
      enclosure(symbol, element, icon);
    } else {
      width = icon.width;
      height = icon.height;
      pinLength = (ref = settings.pinLength) != null ? ref : (decorated ? 5 : 2.5);
      pinLength = (2 * symbol.alignToGrid(width / 2 + pinLength, 'ceil') - width) / 2;
      symbol.attribute('refDes', {
        x: 0,
        y: -height / 2 - settings.space.attribute,
        halign: 'center',
        valign: 'bottom'
      }).attribute('name', {
        x: 0,
        y: height / 2 + settings.space.attribute,
        halign: 'center',
        valign: 'top'
      }).pin({
        number: cathode,
        name: 'C',
        x: width / 2 + pinLength,
        y: 0,
        length: pinLength,
        orientation: 'left',
        passive: true
      }).pin({
        number: anode,
        name: 'A',
        x: -width / 2 - pinLength,
        y: 0,
        length: pinLength,
        orientation: 'right',
        passive: true
      });
      pitch = symbol.alignToGrid(5);
      for (i = j = 0, len = nc.length; j < len; i = ++j) {
        v = nc[i];
        symbol.pin({
          number: v,
          name: 'NC',
          x: (i - (nc.length - 1) / 2) * pitch,
          y: height / 2 + pinLength,
          length: pinLength,
          orientation: 'up',
          nc: true,
          invisible: true
        });
      }
      icon.draw(0, 0);
    }
    return [width, height];
  };

}).call(this);
