// Generated by CoffeeScript 1.10.0
(function() {
  var Icon, TransistorIcon, enclosure,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  enclosure = require('./common/enclosure');

  Icon = require('./common/icon');

  TransistorIcon = (function(superClass) {
    extend(TransistorIcon, superClass);

    function TransistorIcon(symbol, element) {
      var height, width;
      width = 12;
      height = 9;
      this.width = 2 * symbol.alignToGrid(width / 2, 'ceil');
      this.height = 2 * symbol.alignToGrid(height / 2, 'ceil');
      TransistorIcon.__super__.constructor.call(this, symbol, element);
    }

    TransistorIcon.prototype.draw = function(x, y) {
      var a, arrowWidth, dx, dy, space, x1, x2, x3, x4, y1, y2, y3, y4;
      arrowWidth = 1.5;
      this.symbol.lineWidth(this.lineWidth).center(x, y).line(0, -this.height / 2, 0, this.height / 2).line(0, -this.height / 4, this.width / 2, -this.height / 2).line(0, this.height / 4, this.width / 2, this.height / 2);
      if (this.schematic.igbt) {
        space = 1.5;
        this.symbol.line(-this.width / 2, 0, -space, 0).line(-space, -this.height / 2, -space, this.height / 2);
      } else {
        this.symbol.line(-this.width / 2, 0, 0, 0);
      }
      dx = this.width / 2;
      dy = this.height / 4;
      x1 = dx / 2;
      y1 = this.height / 4 + dy / 2;
      x2 = x1 - dx / 4;
      y2 = y1 - dy / 4;
      a = Math.atan(dy / dx);
      if (this.schematic.npn || this.schematic.igbt) {
        x3 = x2 + arrowWidth * Math.sin(a) / 2;
        y3 = y2 - arrowWidth * Math.cos(a) / 2;
        x4 = x2 - arrowWidth * Math.sin(a) / 2;
        y4 = y2 + arrowWidth * Math.cos(a) / 2;
        this.symbol.poly(x1, y1, x3, y3, x4, y4, 'background');
      }
      if (this.schematic.pnp) {
        x3 = x1 + arrowWidth * Math.sin(a) / 2;
        y3 = y1 - arrowWidth * Math.cos(a) / 2;
        x4 = x1 - arrowWidth * Math.sin(a) / 2;
        y4 = y1 + arrowWidth * Math.cos(a) / 2;
        this.symbol.poly(x2, y2, x3, y3, x4, y4, 'background');
      }
      return this.symbol.center(0, 0);
    };

    return TransistorIcon;

  })(Icon);

  module.exports = function(symbol, element) {
    var b, base, c, collector, e, emitter, height, i, icon, j, k, l, len, len1, len2, needEnclosure, pin, pinGroups, pinLength, pins, r, ref, schematic, settings, step, v, valid, width, x, y;
    element.refDes = 'VT';
    schematic = element.schematic;
    settings = symbol.settings;
    pins = element.pins;
    pinGroups = element.pinGroups;
    schematic.showPinNumbers = true;
    icon = new TransistorIcon(symbol, element);
    for (k in pinGroups) {
      v = pinGroups[k];
      switch (k) {
        case 'B':
          base = v;
          break;
        case 'G':
          base = v;
          break;
        case 'C':
          collector = v;
          break;
        case 'E':
          emitter = v;
          break;
        default:
          needEnclosure = true;
      }
    }
    valid = (base != null) && (collector != null) && (emitter != null);
    if ((!valid) || needEnclosure) {
      schematic.showPinNames = true;
      return enclosure(symbol, element, icon);
    } else {
      width = icon.width;
      height = icon.height;
      pinLength = symbol.alignToGrid((ref = settings.pinLength) != null ? ref : 10);
      step = symbol.alignToGrid(5);
      r = width / 2;
      symbol.attribute('refDes', {
        x: width / 2 - settings.fontSize.pin - settings.space.attribute,
        y: -r - settings.space.attribute,
        halign: 'right',
        valign: 'bottom'
      }).attribute('name', {
        x: width / 2 - settings.fontSize.pin - settings.space.attribute,
        y: r + settings.space.attribute,
        halign: 'right',
        valign: 'top'
      }).lineWidth(settings.lineWidth.thick).circle(0, 0, r, settings.fill);
      icon.draw(0, 0);
      y = 0;
      for (i = 0, len = base.length; i < len; i++) {
        b = base[i];
        pin = pins[b];
        pin.x = -width / 2 - pinLength;
        pin.y = y;
        pin.length = pinLength;
        pin.orientation = 'right';
        symbol.pin(pin);
        y += step;
      }
      symbol.line(-width / 2, 0, -width / 2, (base.length - 1) * step);
      x = width / 2;
      for (j = 0, len1 = collector.length; j < len1; j++) {
        c = collector[j];
        pin = pins[c];
        pin.x = x;
        pin.y = -height / 2 - pinLength;
        pin.length = pinLength;
        pin.orientation = 'down';
        symbol.pin(pin);
        x += step;
      }
      symbol.line(width / 2, -height / 2, width / 2 + (collector.length - 1) * step, -height / 2);
      x = width / 2;
      for (l = 0, len2 = emitter.length; l < len2; l++) {
        e = emitter[l];
        pin = pins[e];
        pin.x = x;
        pin.y = height / 2 + pinLength;
        pin.length = pinLength;
        pin.orientation = 'up';
        symbol.pin(pin);
        x += step;
      }
      return symbol.line(width / 2, height / 2, width / 2 + (emitter.length - 1) * step, height / 2);
    }
  };

}).call(this);
